/*******************************************************************************
 *  
 * This file is part of iBioSim. Please visit <http://www.async.ece.utah.edu/ibiosim>
 * for the latest version of iBioSim.
 *
 * Copyright (C) 2017 University of Utah
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the Apache License. A copy of the license agreement is provided
 * in the file named "LICENSE.txt" included with this software distribution
 * and also available online at <http://www.async.ece.utah.edu/ibiosim/License>.
 *  
 *******************************************************************************/
package edu.utah.ece.async.ibiosim.dataModels.biomodel.annotation;

/**
 * 
 *
 * @author 
 * @author Chris Myers
 * @author <a href="http://www.async.ece.utah.edu/ibiosim#Credits"> iBioSim Contributors </a>
 * @version %I%
 */
public class AnnotationNamespace {

	private String prefix;
	private String namespace;
	
	public AnnotationNamespace(String namespace) {
		this.namespace = namespace;
	}
	
	public AnnotationNamespace(String prefix, String namespace) {
		this.prefix = prefix;
		this.namespace = namespace;
	}
	
	public String getPrefix() {
		return prefix;
	}
	
	public String getNamespace() {
		return namespace;
	}
	
	public void setPrefix(String prefix) {
		this.prefix = prefix;
	}
	
	public void setNamespace(String namespace) {
		this.namespace = namespace;
	}
	
	public String toXMLString() {
		if (prefix != null)
			return "xmlns:" + prefix + "=\"" + namespace + "\"";
		return "xmlns=\"" + namespace + "\"";
	}
}
